@ECHO off
ECHO.
ECHO Backing up files in the xgf\encoding and xgf\src directories...
ECHO.

IF "%XPS_HOME2%"=="" GOTO CREATE_VIPP_DIR
SET $vipp_home=%XPS_HOME2%
GOTO CREATE_BACKUP

:CREATE_VIPP_DIR
REM The XPS_HOME2 environment variable does not exist.  Creating path to VIPP files.
SET $vipp_home=%ProgramFiles(x86)%\Xerox-PS\
IF NOT EXIST "%$vipp_home%resources\xgf" GOTO NO_PREVIOUS_INSTALL

:CREATE_BACKUP
REM Create backup directories
MKDIR "%$vipp_home%resources\xgf_backup\encoding"
MKDIR "%$vipp_home%resources\xgf_backup\src"

REM Copy VER file to backup
COPY  "%$vipp_home%resources\xgf\VER" "%$vipp_home%resources\xgf_backup"

REM Copy encoding files to backup
COPY  "%$vipp_home%resources\xgf\encoding\fontlist" "%$vipp_home%resources\xgf_backup\encoding"
COPY  "%$vipp_home%resources\xgf\encoding\nullfl" "%$vipp_home%resources\xgf_backup\encoding"

REM Copy src files to backup
COPY  "%$vipp_home%resources\xgf\src\xgf" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\xgfunix.run" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\xgf.bat" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\xgf.gep" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\xgf.def" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\arb.def" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\cjk.def" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\xgf.pcc" "%$vipp_home%resources\xgf_backup\src"
COPY  "%$vipp_home%resources\xgf\src\xgf.mup" "%$vipp_home%resources\xgf_backup\src"

:GET_MEDIA_SETTING
REM Obtain media information to determine which files to install (A4 or USLetter)
ECHO.
ECHO.
ECHO Select the appropriate default media setting for your area:
ECHO.
ECHO 1: A4
ECHO 2: USLetter
ECHO.
SET $media_setting_num=2
ECHO The default is "2".
SET /p $media_setting_num="[1/2] -> "
IF "%$media_setting_num%"=="1" GOTO SET_MEDIA_SETTING
IF "%$media_setting_num%"=="2" GOTO SET_MEDIA_SETTING
ECHO.
ECHO The value you entered is invalid.
GOTO GET_MEDIA_SETTING

:SET_MEDIA_SETTING
IF "%$media_setting_num%"=="2" GOTO IS_USLETTER
SET $media_setting="A4"
GOTO CHECK_MEDIA_SETTING

:IS_USLETTER
SET $media_setting="USLetter"
GOTO CHECK_MEDIA_SETTING

:CHECK_MEDIA_SETTING
ECHO.
ECHO Default media setting: %$media_setting%
ECHO.
ECHO Is this setting correct?
SET $answer=""
SET /p $answer="[y/n] -> " 
IF "%$answer%"=="n" GOTO GET_MEDIA_SETTING
IF "%$answer%"=="N" GOTO GET_MEDIA_SETTING
IF "%$answer%"=="y" GOTO BEGIN_UPDATE
IF "%$answer%"=="Y" GOTO BEGIN_UPDATE
GOTO CHECK_MEDIA_SETTING

:BEGIN_UPDATE
ECHO.
ECHO Beginning uninstall of VI Compose...
msiexec.exe /x "{7E703461-21B7-4F90-B3A0-7F38D6FC7D27}" /qn
ECHO.
ECHO Beginning install of VI Compose with %$media_setting% media...
msiexec.exe /i XRXxgf.msi MEDIASETTING=%$media_setting%
ECHO.
ECHO Modifying the paths in xgf, xgfunix.run, and startupVIPP.ps and /PageSize in vippconvert.joboptions...
ECHO.
REM Set $displayMessages="true" to display the ModifyXgfunixFiles messages in the console window
SET $displayMessages="true"
REM Do not remove or change the order of the arguments following ModifyXgfunixFiles!
START "" /D "%$vipp_home%resources\xgf\src" /B /WAIT "ModifyXgfunixFiles.exe" %$media_setting% %$displayMessages%
GOTO DONE

:NO_PREVIOUS_INSTALL
ECHO Update Failed.
ECHO FFPS must have been installed on this system prior to running updateVIPP.bat
ECHO.
GOTO END

:DONE
ECHO.
ECHO Update completed.
ECHO.
ECHO.

:END